
precision mediump float;		// Set the default precision to medium. We don't need as high of a precision in the fragment shader.
uniform lowp sampler2D u_Texture;	// The input texture.
varying lowp vec4 v_Color;		// This is the color from the vertex shader interpolated across the triangle per fragment.
varying vec2 v_TexCoordinate;		// Interpolated texture coordinate per fragment.


vec4 toGrayscale(in vec4 color)
{
  float average = (color.r + color.g + color.b) / 3.0;
  return vec4(average, average, average, color.a);
}

vec4 colorize(in vec4 grayscale, in vec4 color)
{
    return (grayscale * color);
}

void main()
{
	//1: same as tinting with normal blending
	//gl_FragColor = v_Color * texture2D(u_Texture, v_TexCoordinate);//32bit texture

	//2: bright red
	//gl_FragColor = texture2D(u_Texture, v_TexCoordinate);
	//float a = v_Color.a * gl_FragColor.a;
	//gl_FragColor = mix(vec4(1.0, 0.0, 0.0, v_Color.a), gl_FragColor, 0.5);//32bit texture
	//gl_FragColor.a = a;

	
	/*gl_FragColor = texture2D(u_Texture, v_TexCoordinate);
	float a = v_Color.a * gl_FragColor.a;
	vec4 color = gl_FragColor;
	float gray = dot(color.rgb, vec3(0.299, 0.587, 0.114));
	gl_FragColor = v_Color * vec4(vec3(gray), a);
	//gl_FragColor = mix(vec4(1.0, 0.0, 0.0, v_Color.a), gl_FragColor, 0.5);
	//gl_FragColor.a = a;*/
	
	
	//vec4 grayscale = toGrayscale(texture2D(u_Texture, v_TexCoordinate));
	//vec4 c = vec4(1.0, 0.0, 0.0, 1.0);
	//vec4 colorizedOutput = colorize(grayscale, c);
	
	//if(colorizedOutput.a > 0.1)
	//	gl_FragColor = v_Color * colorizedOutput;
	
	vec4 color = texture2D(u_Texture, v_TexCoordinate);
	gl_FragColor = v_Color * vec4(dot(color.rgb, vec3(0.299, 0.587, 0.114)), 0.0, 0.0, color.a);
}
